stages:
  - images
  - test

build:
  image: registry.gitlab.com/sosy-lab/software/pqos-wrapper/build:latest
  script:
    - pyinstaller --onefile bin/pqos_wrapper
  artifacts:
    paths:
      - dist/pqos_wrapper


# Static checks
check-format:
  image: python:3.7
  before_script:
    - pip install black
  script:
    - black . --check --diff

.unit-tests:
  script:
    - python3 setup.py test

unit-tests:python-3.5:
  extends: .unit-tests
  image: python:3.5

unit-tests:python-3.6:
  extends: .unit-tests
  image: python:3.6

unit-tests:python-3.7:
  extends: .unit-tests
  image: python:3.7

unit-tests:python-3.8:
  extends: .unit-tests
  image: python:3.8

unit-tests:python-3.9:
  extends: .unit-tests
  image: python:3.9

flake8:
  image: python:3.7
  before_script:
    - pip install flake8-awesome
  script:
    - flake8


# Build Docker images
# following this guideline: https://docs.gitlab.com/ee/ci/docker/using_kaniko.html
.build-docker:
  stage: images
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /root/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --dockerfile $CI_PROJECT_DIR/$DOCKERFILE --destination $CI_REGISTRY_IMAGE/$IMAGE
  only:
    - schedules
    - web

build-docker:build:
  extends: .build-docker
  variables:
    DOCKERFILE: Dockerfile
    IMAGE: build:latest
